/* just goes over complete searchspace, returned path is 
 * guaranteed to be the best, also the slowest method possible 
 */

#include "tsp.h"

unsigned int **main_array;

void full_master(void) {
        register int i;

        if(!(cur_path = (char*)calloc(cities,sizeof(char))))
                handle_error("memory allocation failed");
        if(!(full_best_path = (char*)calloc(cities,sizeof(char))))
                handle_error("memory allocation failed");
        if(!(used = (char*)calloc(cities,sizeof(char))))
                handle_error("memory allocation failed");

        best_length = UINT_MAX;
        used[0] = 1;
        /* we use used array, so we don't have to search if our */
        /* needed member is already used                        */

        full(1);
        printf("total path length is : %ld\n",best_length);
        for(i=0;i<cities;i++)
                printf("%d ->",full_best_path[i]);
        printf(" %d",full_best_path[0]);
        printf("\n");
}

void full(int done) {
        register int i;

        /* check if we have finished with this branch */
        /* and calculate total path length            */
        if( done == cities ) {
                cur_length = 0;
                for(i=1; i<cities; i++) {
                        if( cur_path[i] > cur_path[i-1] )
                                cur_length += main_edge_array[cur_path[i]][cur_path[i-1]];
                        else
                                cur_length += main_edge_array[cur_path[i-1]][cur_path[i]];
                }
                cur_length += main_edge_array[cur_path[cities-1]][0];
                if( cur_length < best_length ) {
                        for(i=0;i<cities;i++)
                                full_best_path[i] = cur_path[i];
                        best_length = cur_length;
                }
        }
        /* if not then recursion continues */
        else  {
                for(i=1;i<cities;i++) {
                        if( used[i] == 0 ) {
                                used[i] = 1;
                                cur_path[done] = i;
                                full(done+1);
                                used[i] = 0;
                        }
                }
        }
}

