#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <limits.h>
#include <ctype.h>

#define HEAP_SIZE 50000
/* heap size variable is used to change the size of a queue used by  */
/* priority queue based BnB algorithm. Programm will switch to depth */
/* first temporarily if queue gets full                              */
#define INFO
/* print info about changes from priority queue based algorithm to   */
/* depth first                                                       */

#define DYNAMIC 0
#define DYNAMIC_WITH_BNB 1

extern void print_help(void);
extern void handle_error(char*);
extern int greedy(int);
extern void full_master(void);
extern void full(int done);
extern int interrupted(void);
extern int interrupted2(void);
extern unsigned int best_estimate(unsigned int*,char*);
extern void bb_complete(int);
extern void estimate_best(void);
extern void dynamic_master(char);
extern unsigned int dynamic_rec(unsigned char,unsigned int);
extern unsigned int dynamic_rec2(unsigned char,unsigned int);
extern int bb(void);
void bb2_master(void);
struct node *queue_remove(struct node**);
struct node *queue_insert(struct node**,struct node*);
void bb_dive(struct node *branch);

struct unused_city {
        unsigned char city;
        struct unused_city *next;
        struct unused_city *prev;
};

/* global variables */
extern unsigned char *full_best_path,*used;
extern unsigned char *cur_path;
extern unsigned long int best_length,cur_length;
extern unsigned int **calculated;
extern unsigned int cities;
extern unsigned int edges;
extern unsigned int best_possible;
extern unsigned int *best_path;
/* all algorithms store their answer in this array */
/* to make possible usage of several algorithms at once */
/* (BnB) uses it */
extern unsigned int *best_array;
/* used by BnB algorithms */
extern unsigned int **main_edge_array;
/* lengths are stored in this array */
extern long int best_pathlength;
/* best pathlength found so far */
/* global variables end */
